#Использовать "./internal"

Перем НастройкиПроектаПолные;
Перем НастройкиПроектаUI;
Перем НастройкиПроекта;
Перем ПоследнееОбновление;

Перем МенеджерСоединений;
Перем МодульПрокси;

#Область СлужебныйПрограммныйИнтерфейс

Процедура Инициализировать(МенеджерСоединений_, МодульПрокси_) Экспорт
	
	МодульПрокси        = МодульПрокси_;
	МенеджерСоединений  = МенеджерСоединений_;
	ПоследнееОбновление = ТекущаяДата();
	
	ЗаполнитьНастройки(Истина);
	
КонецПроцедуры

Функция ВернутьНастройкиПроектаПолные() Экспорт
	
	ЗаполнитьНастройки();
	Возврат НастройкиПроектаПолные;
	
КонецФункции

Функция ВернутьНастройкиПроектаUI() Экспорт
	
	ЗаполнитьНастройки();
	Возврат НастройкиПроектаUI;
	
КонецФункции

Функция ВернутьНастройку(Знач Имя) Экспорт
	
	ЗаполнитьНастройки();
	Настройка = НастройкиПроекта.Получить(Имя);

	Возврат Настройка;
	
КонецФункции

Функция ЗаписатьНастройкиПроекта(Знач Данные) Экспорт
	
	СоединениеRW = МенеджерСоединений.ПолучитьСоединениеRW();
	Результат    = МодульПрокси.ЗаполнитьНастройкиПроекта(СоединениеRW, Данные);
	ЗаполнитьНастройки(Истина);
	
	Возврат Результат;
	
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ЗаполнитьНастройки(Знач Принудительно = Ложь)

	ТекущаяДата = ТекущаяДата();
	
	Если Принудительно Или ТекущаяДата > ПоследнееОбновление + 60 Тогда
		ПоследнееОбновление = ТекущаяДата;
	Иначе
		Возврат;
	КонецЕсли;
	
	СоединениеRO    = МенеджерСоединений.ПолучитьСоединениеRO();
	НастройкиИзБазы = МодульПрокси.ПолучитьНастройкиПроекта(СоединениеRO);
	
	Если Не НастройкиИзБазы["result"] Тогда
		ВызватьИсключение НастройкиИзБазы["error"];	
	КонецЕсли;
	
	НастройкиПроектаПолные = НастройкиИзБазы;
	НастройкиПроекта       = Новый Соответствие();
	ТаблицаНастроекUI      = Новый Массив;
	
	Для Каждого Настройка Из НастройкиИзБазы["data"] Цикл

		НастройкиПроекта.Вставить(Настройка["name"], Настройка["value"]);

		Если Не Настройка["name"] = "ui_password" Тогда
			ТаблицаНастроекUI.Добавить(Настройка);
		КонецЕсли;

	КонецЦикла;

	НастройкиПроектаUI = Новый Структура("result,data", истина, ТаблицаНастроекUI);
	
КонецПроцедуры

#КонецОбласти
