#Использовать oint
#Использовать "./internal"

Перем ПутьСервера;
Перем ОбработчикСеансов;
Перем ОбработчикСтатики;
Перем ХранилищеНастроек;
Перем БазовыйПуть;

#Область СлужебныйПрограммныйИнтерфейс

Процедура Инициализировать(ПутьСервера_, ОбработчикСеансов_, ХранилищеНастроек_) Экспорт

	ПутьСервера       = ПутьСервера_;
	ОбработчикСеансов = ОбработчикСеансов_;
	ХранилищеНастроек = ХранилищеНастроек_;

	ОбработчикСтатики = Новый("StaticProcessor");
	ОбработчикСтатики.Инициализировать(ХранилищеНастроек, ПутьСервера);

КонецПроцедуры

Функция ОсновнаяОбработка(Знач Контекст, Знач Путь) Экспорт

	Результат = Неопределено;
	Путь      = ?(ЗначениеЗаполнено(Путь), Путь, "index.html");

	Контекст.Ответ.КодСостояния = 200;

	Если ОбработчикСтатики.ВернутьСтатику(Путь, Контекст) Тогда
		Возврат Результат;
	КонецЕсли;

	Если Путь = "ui" Тогда

		ВернутьСтраницуUI(Контекст);

	ИначеЕсли Путь = "ui/login" Тогда

		Результат = АвторизоватьСеанс(Контекст);

	ИначеЕсли Путь = "ui/logout" Тогда

		ОбработчикСеансов.УдалитьСеанс(Контекст);
		ОбработчикСтатики.Перенаправление("ui", Контекст);

	Иначе
		Результат = Toolbox.ОшибкаОбработки(Контекст, 404, "Not Found");
	КонецЕсли;

	ВыполнитьСборкуМусора();

    Возврат Результат;

КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ВернутьСтраницуUI(Контекст)

	Контекст.Ответ.КодСостояния = 200;
	
	Если ОбработчикСеансов.АвторизованныйСеанс(Контекст) Тогда 

		ОбработчикСтатики.ВернутьСтатику("console.html", Контекст);

	Иначе

		ОбработчикСтатики.ВернутьСтатику("login.html", Контекст);

	КонецЕсли;

КонецПроцедуры

Функция АвторизоватьСеанс(Контекст)

	Результат = ОбработчикСеансов.АвторизоватьСеанс(Контекст);

	Возврат Результат;

КонецФункции

#КонецОбласти